<?php
/**
 * Created by PhpStorm.
 * User: phillipesilva
 * Date: 16/10/2015
 * Time: 09:50
 */

namespace Factory;

use Zeedhi\DevOps\Model\Configurationmanager\Entities\Package as PackageEntity;
use Zeedhi\DevOps\Model\Configurationmanager\Entities\PackageContents;

class Package {
    /**
     * @param PackageEntity $package
     * @param $release
     * @param $name
     * @param $path
     * @param $description
     * @param $product
     * @param $fileName
     * @param $pathToDeploy
     * @return PackageEntity
     */
    public function setPackageRecords(PackageEntity $package = null, $release, $name, $path, $description, $fileName, $pathToDeploy, $product = null) {
        if(!$package) {
            $package = new PackageEntity();
        }
        $package->setRelease($release);
        $package->setName($name);
        $package->setPath($path);
        $package->setDescription($description);
        $package->setFileName($fileName);
        $package->setPathToDeploy($pathToDeploy);
        $package->setProduct($product);

        return $package;
    }

    /**
     * @param PackageContents $packageContents
     * @param $package
     * @param $name
     * @param $path
     * @param $fileName
     * @return PackageContents
     */
    public function setPackageContentsRecords(PackageContents $packageContents = null, PackageEntity $package, $name, $path, $fileName) {
        if(!$packageContents) {
            $packageContents = new PackageContents();
        }
        $packageContents->setPackage($package);
        $packageContents->setName($name);
        $packageContents->setPath($path);
        $packageContents->setFileName($fileName);

        return $packageContents;
    }
} 