<?php
/**
 * Created by PhpStorm.
 * User: phillipesilva
 * Date: 04/02/2016
 * Time: 08:53
 */

namespace Factory;

use Zeedhi\DevOps\Model\Configurationmanager\Entities\Product as ProductEntity;
use Zeedhi\DevOps\Model\Profile\Entities\ZhUser;
use Zeedhi\DevOps\Model\Projectmanagement\Entities\Project;

class Product {
    /**
     * @param ProductEntity $product
     * @param $project
     * @param $name
     * @param $baseUrl
     * @param $description
     * @param $version
     * @param $revision
     * @param $build
     * @param $isActive
     * @param $numberLtsAvailable
     * @return ProductEntity
     */
    public function setProductRecords(ProductEntity $product = null, $project, $name, $baseUrl,
                                      $description, $version, $revision, $build, $isActive = 'Y', $numberLtsAvailable = null)
    {
        if(!$product) {
            $product = new ProductEntity();
        }
        $product->setProject($project);
        $product->setName($name);
        $product->setBaseUrl($baseUrl);
        $product->setDescription($description);
        $product->setVersion($version);
        $product->setRevision($revision);
        $product->setBuild($build);
        $product->setIsActive($isActive);
        $product->setNumberLtsAvailable($numberLtsAvailable);

        return $product;
    }
} 