<?php

namespace Service;

use Util\InstanceProvider;
use Doctrine\ORM\EntityManager;
use Zeedhi\DevOps\Util\Utilities as DevOpsUtilities;

class ProductServer {
    
    /** @var EntityManager $entityManager */
    protected $entityManager;
    
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }
    
    public function findProductWithServerBasePath($conditions)
    {
        $serverId = DevOpsUtilities::getValueInFilterDataSourceByName($conditions, 'SERVER_ID', true);
        $filters = DevOpsUtilities::createQueryFiltered($conditions);
        return InstanceProvider::getRepository()->getProductServer()->findProductWithServerBasePath($serverId, $filters);   
    }
    
}