/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CONTCORR                                                 */
/* Tabela : CONTCORR                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 23/01/2004 - Newton N. Santos                                              */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CONTCORR
BEFORE INSERT OR UPDATE OR DELETE
ON CONTCORR FOR EACH ROW
BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCCOR := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDCONTCORR,0)   <> NVL(:NEW.CDCONTCORR,0)) OR
         (NVL(:OLD.CDREDUCONT,0)   <> NVL(:NEW.CDREDUCONT,0)) OR
         (NVL(:OLD.DSCONTCORR,0)   <> NVL(:NEW.DSCONTCORR,0)) OR
         (NVL(:OLD.CDBANCO,0)      <> NVL(:NEW.CDBANCO,0))    OR
         (NVL(:OLD.CDAGENCIA,0)    <> NVL(:NEW.CDAGENCIA,0))  OR
         (NVL(:OLD.CDEMPRESA,0)    <> NVL(:NEW.CDEMPRESA,0)) OR
         (NVL(:OLD.CDCONTCTBL,0)   <> NVL(:NEW.CDCONTCTBL,0)) OR
         (NVL(:OLD.IDTIPOCCORR,0)  <> NVL(:NEW.IDTIPOCCORR,0)) OR
         (NVL(:OLD.CDCCTBCAUCIO,0) <> NVL(:NEW.CDCCTBCAUCIO,0))    OR
         (NVL(:OLD.CDCEDENTEBAN,0) <> NVL(:NEW.CDCEDENTEBAN,0)) THEN
         :NEW.DTULTATUCCOR := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CONTCORR', '', 'CDREDUCONT='||:OLD.CDREDUCONT||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CONTCORR MODIFY DTULTATUCCOR DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_CONTCORR','5.07.015'); END;
/

