/*
 @C:\Web_635\Sql\End_Conv\Oracle\3967_PEDFUNO_PESOLIQUIDO_PEDIDO.SQL

 Descrio:
 Funo para retornar o peso liquido do pedido

 Parmetros

 P_CDFILIAL    - Cdigo da filial
 P_NRPEDIDO    - Nmero do pedido

 raise_application_error(-20501, '' , True);
*/

create or replace FUNCTION PESOLIQUIDO_PEDIDO(
   P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE,
   P_NRPEDIDO     IN PEDIDO.NRPEDIDO%TYPE) RETURN NUMBER IS

   V_VRPLIQVOLPED NUMBER;
BEGIN
   V_VRPLIQVOLPED := 0;

   SELECT SUM( I.QTITEMPED * NVL(A.VRPESOLIQUPR,0))
     INTO V_VRPLIQVOLPED
     FROM PRODUTO A,  ITEMPEDIDO I
    WHERE (I.CDPRODUTO = A.CDPRODUTO)
      AND (I.CDFILIAL  = P_CDFILIAL)
      AND (I.NRPEDIDO  = P_NRPEDIDO);

   RETURN(V_VRPLIQVOLPED);
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('PESOLIQUIDO_PEDIDO','6.35.020'); END;
/
